{==============================================================}
{                                                              }
{             Saved as: KEYDEFS.INC                            }
{               Author: Pat Anderson                           }
{        Last modified: Fri 01-31-90                           }
{              Purpose: Define key code values returned        }
{                       by GetKey function as constants        }
{                                                              }
{==============================================================}

CONST
  {Control code constants}
  BackSpace = #8; Tab = #9; LineFeed = #10;
  FormFeed = #12; Enter = #13; Esc = #27; Space = #32;

  {Constants for character codes returned by GetKey function}
  {Cursor pad constants}
  Home = #199; End_Key = #207; PgUp = #201; PgDn = #209;
  CtlHome = #247; CtlEnd = #245; CtlPgUp = #132; CtlPgDn = #246;
  LeftArrow = #203; RightArrow = #205; UpArrow = #200; DownArrow = #208;
  CtlLeft = #243; CtlRight = #244;

  {Insert/delete key constants}
  Ins = #210; Del = #211;

  {Function key constants}
  F1 = #187; F2 = #188; F3 = #189; F4 = #190; F5 = #191;
  F6 = #192; F7 = #193; F8 = #194; F9 = #195; F10 = #196;

  {Shifted function key constants}
  ShF1 = #212; ShF2 = #213; ShF3 = #214; ShF4 = #215; ShF5 = #216;
  ShF6 = #217; ShF7 = #218; ShF8 = #219; ShF9 = #220; ShF10 = #221;

  {Control-function key constants}
  CtlF1 = #222; CtlF2 = #223; CtlF3 = #224; CtlF4 = #225; CtlF5 = #226;
  CtlF6 = #227; CtlF7 = #228; CtlF8 = #229; CtlF9 = #230; CtlF10 = #231;

  {Alt-function key constants}
  AltF1 = #232; AltF2 = #233; AltF3 = #234; AltF4 = #235; AltF5 = #236;
  AltF6 = #237; AltF7 = #238; AltF8 = #239; AltF9 = #240; AltF10 = #241;

  {Alt-alpha key constants}
  {QWERTUIOP row}
  AltQ = #144; AltW = #145; AltE = #146; AltR = #147; AltT = #148;
  AltY = #149; AltU = #150; AltI = #151; AltO = #152; AltP = #153;
  {ASDFGHJKL row}
  AltA = #158; AltS = #159; AltD = #160; AltF = #161; AltG = #162;
  AltH = #163; AltJ = #164; AltK =  #165; AltL = #166;
  {ZXCVBNM row}
  AltZ = #172; AltX = #173; AltC = #174; AltV = #175; AltB = #176;
  AltN = #177; AltM = #178;
  {1234567890 row}
  Alt1 = #248; Alt2 = #249; Alt3 = #250; Alt4 = #251; Alt5 = #252;
  Alt6 = #253; Alt7 = #254; Alt8 = #255; Alt9 = #128; Alt0 = #129;

